<?php
	##### for OpenBiblio 0.4.0
	##### requires a reference within "bibio_new_form.php" per readme file.

	##### the following lines should be modified for your conditions
	$my_callNmbrType = 'loc';  			 ##-- 'loc', 'dew', or 'local' are supported
	$host =		'z3950.loc.gov:7090';  ##-- see http://www.loc.gov/z3950/ for others
#	$host =		'z3950.dbf.ddb.de:210';  ##-- see http://www.loc.gov/z3950/ for others
	$database =	'voyager'; 					 ##-- as required for the server
#	$database =	'iltis'; 					 ##-- as required for the server
	##### end of user modifiable area

	$err_level =	error_reporting();		## capture current level
	$err_fnctn =	set_error_handler;		## capture current function
	error_reporting(E_PARSE | E_CORE_ERROR | E_COMPILE_ERROR | E_USER_ERROR);		## set local level
	set_error_handler('lkup_err_Handler');	## set local function

	$srchBy =	$_GET['srchBy'];
	$lookupVal =	$_GET['lookupVal'];
	$num_hosts =	1;
	$syntax =	"usmarc";

	##----------- support functions -----------

?>

<script language="JavaScript">
	function chkIsbn (sInput) {
		// validate isbn string; return TRUE if checksum is valid
		var isbn = "";
		var nSum = 0;
		var sSum = "";
		var nAdr = 0;

		// remove any "-" or space char user may have entered
		isbn = sInput.replace(/-| /g, "");

		if (isbn.length < 10) {
			alert($loc->getText("lookupalert1"));
			return false;
		}
		else if (isbn.substr(0,2) == "78") {
			// this is a bar code reader input, so let it go to server
			return true;
		}
		else {	// test check digit
			for (var i=0; i<9; i++) {
				nAdr = isbn.substr(i,1);
				nSum += (10-i) * nAdr;
			}
			nSum = nSum % 11;
			nSum = 11 - nSum;
			if (nSum == 10)
				sSum = "x";
			else if (nSum == 11)
				sSum = "0";
			else
				sSum = nSum.toString();
			//alert("\nisbn chk digit="+isbn.substr(9,1)+"\ncomputed ="+sSum);
			if (sSum != isbn.substr(9,1)) {
				alert($loc->getText("lookupalert2"));
				return false;
			}
			else
				return true;
		}
	}
	function chkBookId () {
		var radGrp = document.lookupform.srchBy;
		var sId = document.lookupform.lookupVal.value;
		var rslt = false;

		for (var i=0; i<radGrp.length; i++) {
			var e = radGrp[i];
			if (e.checked) {
				var nType = e.value;
				//alert("in chkBookId, sID="+sId+", nType="+nType);		
				if (nType == 7) {
					rslt = chkIsbn(sId);
					if (rslt != true) {
						document.lookupform.lookupVal.focus();
					}
				else if (nType == 8)
					rslt = true;	// ISSN
				}
				else if (nType == 9)
					rslt = true;	// LOCN
				}
				return rslt;
			}
		}
	}
</script>

<?php
	function lkup_err_Handler($err, $err_str, $fn, $ln, $sym) {
		$badOnes = (E_ERROR | E_PARSE | E_CORE_ERROR | E_COMPILE_ERROR | E_USER_ERROR);
		if (error_reporting() == $badOnes) {
			echo "<p>".$loc->getText("lookuperror1")."'<b>$err_str</b>'".$loc->getText("lookuperror2")."$ln".$loc->getText("lookuperror3")."<i>$fn</i>.</p>";
    	header("Location: ../catalog/biblio_new_form.php");
			error_reporting($err_level);		// restore original value
			set_error_handler($err_fnctn);	// restore original handler
			exit();
		}
	}

	##-----------

	function extract_marc_fields($ar) {
		global $my_callNmbrType;
		$marcFlds = array();
		$subFlds = array();
		
    $nl = "";
    reset($ar);
    //var_dump($ar);
    while(list($key,list($tagpath,$data))=each($ar)) {
      //echo $key . "!!!" . $tagpath . "!!!" . $data . '<br />' ;
      if (ereg("^\(3,([^)]*)\)\(3,([^)]*)\)$",$tagpath,$res)) {
    		//echo '<br /><br />---           Tag : '; #<<<<<<<<<<<<<<<<<<
        //echo $nl; #<<<<<<<<<<<<<<<<<<
        $nl = "";
        //echo $res[1] . ' ' . ereg_replace(" ", "_", $res[2]); #<<<<<<<<<<<<<<<<<<
				if (!empty($theTag)) {
					$marcFlds["$theTag"] = $subFlds;	// store previous data
				}
        $theTag = "$res[1]";
        $subFlds = array(); //reset($subFlds);
    	}
    	elseif (ereg("^\(3,([^)]*)\)\(3,([^)]*)\)\(3,([^)]*)\)$",$tagpath,$res)) {
      	//echo '<br />---         sub field : '; #<<<<<<<<<<<<<<<<<<
        //echo ' <b>' . $res[3] . '</b> ' . $data . "\n"; #<<<<<<<<<<<<<<<<<<
        $nl='<br />';
        $subFlds["$res[3]"] = "$data";

        ##### -- normal processing
        $data = trim(htmlspecialchars($data));
				$fldId = ($theTag . $res[3]);
				if (isset($_POST[$fldId])) $_POST[$fldId] .= '; ';
				switch ($theTag) {
				case '538':  ##### Systems Details Note (R)
					if	($res[3] == 'a')
						$_POST['520a'] .= $data; ## Note (NR)
					break;
        case '650':  ##### Subject Added Entry - Topical Term (R)
        	if     ($res[3] == 'a') {
						if (isset($subjectCnt)) $subjectCnt++; else $subjectCnt = '';
	        		$_POST["650a$subjectCnt"] .= $data; // topical term (NR)
					}
					else
        		$_POST["650a$subjectCnt"] .= ', ' . $data; // details (NR)
        	break;
				default:		##### everything else
					// echo $theTag . $res[3] . "==>" . $data . '<br />' ;
					$_POST[$fldId] .= $data;
					break;
				}
      }
    }

    echo $nl;

    //print_r($marcFlds);
	}

	##### ----------- end support functions ----------------

	if (empty($lookupVal) || empty($srchBy)) {
		//echo "srchby=$srchBy  " . 'lookupVal=' . htmlspecialchars($lookupVal) . '<br />';

		##### display initial screen for user input
?>
		<form name="lookupform" method="get" action="../catalog/biblio_new_form.php" onSubmit="return chkBookId()">
		<input type = "hidden" name="reset" value="Y">

		<table class="primary">
		<tr>
			<th colspan=3><?php print $loc->getText("lookupmessage1"); ?></th>
		</tr>
		<tr>
			<td class="primary"><?php print $loc->getText("lookupmessage2"); ?></th>
			<td class="primary">
				<!-- input type="text" size="30" name="lookupVal"  value="0824794761" -->
				<input type="text" size="30" name="lookupVal"  value="">
			</td>
			<td class="primary" rowspan="2">
				<input type="radio" name="srchBy" checked="1" value="7"><?php print $loc->getText("lookupmessage3"); ?><br>
				<input type="radio" name="srchBy" value="8"><?php print $loc->getText("lookupmessage4"); ?><br>
				<input type="radio" name="srchBy" value="9"><?php print $loc->getText("lookupmessage5"); ?>
			</td>
		</tr>
		<tr>
			<td class="primary" colspan="2" align="center">
				<!-- input type="submit" name="action" value="Search" class="button"  onclick="chkBookId()" -->
				<input type="submit" name="action" value="<?php print $loc->getText("lookupmessage6"); ?>" class="button">
			</td>
		</tr>
		</table>
		</form>
		
<?php
	}
	else {
		//echo 'original Query specification is: ' . htmlspecialchars("$srchBy $lookupVal") . '<br />';
		//echo 'srchBy: ' . $srchBy . '<br />';
		if ($srchBy == "7") {
			$srchByName = 'ISBN';
			## remove any "-" char user may have entered
			$lookupVal = str_replace("-", "", $lookupVal);
			## remove any space char user may have entered
			$lookupVal = str_replace(" ", "", $lookupVal);

			## test if its a scanned EAN code
			if (substr($lookupVal, 0,3) == "978") {
				## extract the isbn from the scanner jumble
				$isbn = substr($lookupVal, 3,9);
				//echo 'raw isbn: ' . $isbn . '<br />';
				
				$xSum = 0;
				$add = 0;
				for ($i=0; $i<9; $i++) {
					$add = substr($isbn, $i,1);
					$xSum += (10-$i) * $add;
				}
				$xSum %= 11;
				$xSum = 11-$xSum;
				if ($xSum == 10)
					$xSum = "x";
				if ($xSum == 11)
					$xSum = "0";
				//echo 'checksum: ' . $xSum . '<br />';
				
				$lookupVal = $isbn . $xSum;
			}
			//echo 'final isbn: ' . $lookupVal . '<br />';
		}

		else if ($srchBy == "8") {
			$srchByName = 'ISSN';
			## remove any "-" char user may have entered
			$lookupVal = str_replace("-", "", $lookupVal);
			## remove any space char user may have entered
			$lookupVal = str_replace(" ", "", $lookupVal);
			}

		else if ($srchBy == "9") {
			$srchByName = 'LCCN';
			## remove "-" and fill with "0" to make 8 char long
			$pos = strPos($lookupVal, "-");
			if ($pos > 0) {
				$lccnLeft = subStr($lookupVal,0,$pos);
				$lccnRight = subStr($lookupVal,$pos+1,6);
				$lccnRight = str_pad($lccnRight,6,"0",STR_PAD_LEFT);
				$lookupVal = $lccnLeft . $lccnRight;
			}
			//echo 'final lccn: ' . $lookupVal . '<br />';
		}
		
		# perform a search for wanted material
		$qry = '@attr 1=' . $srchBy . ' ' . $lookupVal;
		//echo 'Query specification is: ' . htmlspecialchars($qry) . '<br />';

		//echo "connecting to: $host<br />";
		$connOK = yaz_connect($host);
		if (! $connOK) {
			//echo 'yaz setup not successful! <br />';
			trigger_error($loc->getText("lookuperror4")."$host".$loc->getText("lookuperror5")."<br />", E_USER_ERROR);
			die($loc->getText("lookuperror5"));
		}
		else {
			//echo 'yaz setup successful! <br />';
			$id = $connOK;
			yaz_database($id, $database);
			yaz_syntax($id,$syntax);
			yaz_element($id, "F");
			
			if (! yaz_search($id,"rpn",$qry)) 
				trigger_error($loc->getText("lookuperror6")."<br />", E_USER_NOTICE);
		}
		//echo "waiting for responses. <br />";
		yaz_wait();

		## did we make it?
		$error = yaz_error($id);
		if (!empty($error)) {
			trigger_error($loc->getText("lookuperror7")."<br />", E_USER_ERROR);
			//$errno = yaz_errno($id);
			//$addinfo = yaz_addinfo($id);
echo "Error: $error (code $errno ) $addinfo <br />";
    	//header("Location: ../catalog/biblio_new_form.php");
			//die();
		}
		else {
			$hits = yaz_hits($id);
			//echo "Result Count $hits <br />";
		}
		
		if ($hits == 0) {
			echo $loc->getText("lookuperror8") . $srchByName . ' = ' . $lookupVal . ' !' . '<br />';
		}
		else {
			echo '<b>' . $loc->getText("lookupmessage7") . '</b><br>';
			if ($hits == 1) {
				$ar = yaz_record($id,1,"array");
				if (! empty($ar)) {
					$rec = yaz_record($id,1,"string");
					extract_marc_fields($ar);
				}
			}
			else if ($hits > 1) {
				echo '<font color="#ff0000">' . $hits . $loc->getText("lookupmessage8") . $loc->getText("lookupmessage9").'</font><br>';
//				echo 'please save the lookup value for use as test values to improve this feature.<br>';

				## display individual MARC records
				for ($p = 1; $p <= 10; $p++) {
					$ar = yaz_record($id,$p,"array");
					$rec = yaz_record($id,$p,"string");
					//print_r($ar);
					if (! empty($ar)) 
						extract_marc_fields($ar);
				}
			}

		##### -- post appropriate tag data to the CallNmbr fields
		if (isset($_POST['callNmbr1'])) $_POST['callNmbr1'] .= '; ';
		//echo "my_callNmbrType = " . $my_callNmbrType . '<br />' ;				
		switch ($my_callNmbrType)  {
		case 'loc':
      $_POST['callNmbr1'] .= $_POST['050a'];
      $_POST['callNmbr2'] .= $_POST['050b'];
			break;
		case 'dew':
      $_POST['callNmbr1'] .= $_POST['082a'];
      $_POST['callNmbr2'] .= $_POST['082b'];
			break;
		case 'local':
			## leave the fields blank for user entry
			break;
		default:
			echo $loc->getText("lookuperror9").' <br />';
		}

    ##### -- default data to satisfy the biblio objects validation needs
    if (!isset($_POST['callNmbr1'])) $_POST['callNmbr1'] = $loc->getText("lookuperror10"); // call nmbr
    if (!isset($_POST['245a'])) $_POST['245a'] = $loc->getText("lookuperror11"); // title
    if (!isset($_POST['100a'])) $_POST['100a'] = $loc->getText("lookuperror12"); // author

			$_POST['reset'] = 'Y'; ## else get wiped out by post?
			$_POST['opacFlg'] = 'CHECKED';

			## make data available on new bibliography form
    	$HTTP_SESSION_VARS["postVars"] = $_POST;
    	$postVars = $HTTP_SESSION_VARS["postVars"];
    	//print_r($postVars);
		}
	}

	error_reporting($err_level);		## restore original value
	set_error_handler($err_fnctn);	## restore original handler
?>


